/**************************************************************
  (C) 1997 by Achim Kaiser

  You may distribute under the terms of the GNU General Public
  License as specified in the COPYING file.
**************************************************************/

#include "callmanager.h"
#include "gui.h"
#include "filemanager.h"
#include "iconmanager.h"
#include "global.h"
#include <malloc.h>
#include <string.h>

/*subfolder="" */

int CopyCall(int x,int y,char *filenames,char *subfolder,int kind)
{
  int i=1;
  int j;
  int k,l;
  int answer=2;
  char *text;
  char *text2;
  char *rename;
  int backstatus=0;
  int status;
  do {
    j=i;
    do {
      j++;
    } while (filenames[j]!=' ' && filenames[j]!=0);
    text=malloc(j-i+1);
    strncpy(text,filenames+i,j-i);
    text[j-i]=0;
    
    k=0;l=0;
    while (text[k+1]!=0){
      if (text[k]=='/')
	l=k;
      k++;
    }
    text2=malloc(strlen(text+l)+strlen(GetPath())+strlen(subfolder)+1);
    strcpy(text2,GetPath());
    strcat(text2,subfolder);
    strcat(text2,text+l+1);
    if (FileExist(text2)==0) {
      if (answer!=3) {
	do {
	  answer=OverwriteQuestion(text2,&rename);
	  if (answer==5) {
	    if (text2[strlen(text2)-1]=='/') {
	      free(text2);
	      text2=malloc(strlen(rename)+strlen(GetPath())+strlen(subfolder)+2);
	      strcpy(text2,GetPath());
	      strcat(text2,subfolder);
	      strcat(text2,rename);
	      strcat(text2,"/");
	    } else {
	      free(text2);
	      text2=malloc(strlen(rename)+strlen(GetPath())+strlen(subfolder)+1);
	      strcpy(text2,GetPath());
	      strcat(text2,subfolder);
	      strcat(text2,rename);
	    }
	  }
	  free(rename);
	} while(answer==5 && FileExist(text2)==0);
      }
      if (answer==2 || answer==3) {
	EraseFile(text2);
	if (subfolder[0]==0)
	  EraseIcon(text2);
      } else
	backstatus=-2;
    }
    if (InItSelf(text)==True) {
      answer=4;
      backstatus=-2;
    }
    if (answer==2 || answer==3 || answer==5) {
      if (kind==NORMAL)
	status=CopyFile(text,text2,subfolder);
      else
	status=RealCopyFile(text,text2,subfolder);
      if (status==0) {
	if (subfolder[0]==0)
	  NewIcon(text2,text,x,y,i);
      } else 
	backstatus=-1;
    }
      i=j+1;
    free(text);
    free(text2);
  } while (filenames[j]!=0 && answer!=1);
  return(backstatus);
}

void EraseCall(char *filenames,int ask,int remote)
{
  int i=1;
  int j;
  char *text;
  int status;
  int answer=2;
  do {
    j=i;
    do {
      j++;
    } while (filenames[j]!=' ' && filenames[j]!=0);
    text=malloc(j-i+1);
    strncpy(text,filenames+i,j-i);
    text[j-i]=0;
    if (ask==True && answer!=3) {
      if (remote==True)
	answer=EraseQuestionOnDifferent(text);
      else
	answer=EraseQuestion(text);
    }
    if (ask==False || answer==3 || answer==2) {
      status=EraseFile(text);
      if (status==0 && remote==False){
	if (GetKindOfWindow()==STRUCTURE)
	  UpdateIcons(True);
	else
	  EraseIcon(text);
      }
    }
    free(text);
    i=j+1;
  } while (filenames[j]!=0 && answer!=1);
}

void LinkCall(int x,int y,char *filenames,char *subfolder)
{
  int i=1;
  int j;
  char *text;
  int status;
  do {
    j=i;
    do {
      j++;
    } while (filenames[j]!=' ' && filenames[j]!=0);
    text=malloc(j-i+1);
    strncpy(text,filenames+i,j-i);
    text[j-i]=0;
    status=LinkFile(text,subfolder);
    if (status==0 && subfolder[0]==0)
      NewIcon(text,text,x,y,i);
    free(text);
    i=j+1;
  } while (filenames[j]!=0);
}
